class ImFontConfig:
    FontBuilderFlags: int = 0

class ImBool:
    def __init__(self, value: bool = False):
        self.v = value

class ImInt:
    def __init__(self, value: int = 0):
        self.v = value

class ImFloat:
    def __init__(self, value: float = 0):
        self.v = value

class ImString:
    def __init__(self, value: str):
        self.v = value

class ImStringList:
    def __init__(self, value: list):
        self.v = value

class ImVec2:
    def __init__(self, x: float = 0, y: float = 0):
        self.x = x
        self.y = y

class ImVec4:
    def __init__(self, *args, **kwargs):
        """
        Args:
            x, y, z, w OR ImVec4
        """
        self.x = x
        self.y = y
        self.z = z
        self.w = w

class ImIntVec4:
    def __init__(self, v0: int = 0, v1: int = 0, v2: int = 0, v3: int = 0):
        self.v0 = v0
        self.v1 = v1
        self.v2 = v2
        self.v3 = v3

class ImColor:
    def __init__(self, *args, **kwargs):
        """
        Args:
            r: int = 0, g: int = 0, b: int = 0, a: int = 255
            OR
            ImVec4
        """
        self.Value = ImVec4(**kwargs)

class ImGuiStyle:
    ItemSpacing: ImVec2

class ImGuiTextFilter:
    def __init__(self, default_filter: str = ""):
        self.InputBuf = default_filter
    def Draw(self, label: str = "Filter (inc,-exc)", width: float = 0.0):
        pass
    def Clear(self):
        pass
    def PassFilter(self, text: str, text_end: str = 0) -> bool:
        pass
    def IsActive(self) -> bool:
        pass

class ImGui:
    @staticmethod
    def Begin(name: str, is_open: Optional[ImBool] = ImBool(True), flags: int = 0) -> bool:
        pass
    @staticmethod
    def Begin(name: str, flags: int = 0) -> bool:
        pass
    @staticmethod
    def End():
        pass
    @staticmethod
    def BeginGroup():
        pass
    @staticmethod
    def EndGroup():
        pass
    @staticmethod
    def BeginTooltip():
        pass
    @staticmethod
    def EndTooltip():
        pass
    @staticmethod
    def BeginChild(str_id: str, size: ImVec2 = ImVec2(), border: bool = false, flags: int = 0) -> bool:
        pass
    @staticmethod
    def EndChild():
        pass
    @staticmethod
    def PushID(int_id: int):
        pass
    @staticmethod
    def PopID():
        pass
    @staticmethod
    def SetNextWindowPos(pos: Imvec2, cond: int = 0, pivot: ImVec2 = ImVec2()):
        pass
    @staticmethod
    def SetNextWindowSize(pos: Imvec2, cond: int = 0):
        pass
    @staticmethod
    def SetNextWindowBgAlpha(alpha: float):
        pass
    @staticmethod
    def GetWindowPos() -> ImVec2:
        pass
    @staticmethod
    def GetWindowSize() -> ImVec2:
        pass
    @staticmethod
    def GetContentRegionMax() -> ImVec2:
        pass
    @staticmethod
    def SetWindowFontScale(scale: float):
        pass
    @staticmethod
    def BeginTabBar(str_id: str, flags: int = 0) -> bool:
        pass
    @staticmethod
    def EndTabBar():
        pass
    @staticmethod
    def BeginTabItem(label: str, p_open: ImBool = 0, flags: int = 0) -> bool:
        pass
    @staticmethod
    def EndTabItem():
        pass
    @staticmethod
    def SetCursorPos(pos: ImVec2):
        pass
    @staticmethod
    def GetCursorPos() -> ImVec2:
        pass
    @staticmethod
    def IsItemHovered(flags: int = 0):
        pass
    @staticmethod
    def GetScrollX() -> float:
        pass
    @staticmethod
    def GetScrollY() -> float:
        pass
    @staticmethod
    def GetScrollMaxX() -> float:
        pass
    @staticmethod
    def GetScrollMaxY() -> float:
        pass
    @staticmethod
    def SetScrollHereX(center_x_ratio: float = 0.5) -> float:
        pass
    @staticmethod
    def SetScrollHereY(center_y_ratio: float = 0.5) -> float:
        pass
    @staticmethod
    def PushItemWidth(item_width: float):
        pass
    @staticmethod
    def AddFontFromFileTTF(filename: str, size_pixels: float, config: ImFontConfig = ImFontConfig()) -> int:
        pass
    @staticmethod
    def RemoveFont(font_id: int) -> bool:
        pass
    @staticmethod
    def PushFont(font_id: int):
        pass
    @staticmethod
    def PopFont():
        pass
    @staticmethod
    def CalcTextSize(
        test: str, text_end: Optional[str] = None, hide_text_after_double_hash: bool = False, wrap_width: float = -1.0
    ):
        pass
    @staticmethod
    def PushTextWrapPos(wrap_local_pos_x: float = 0.0):
        pass
    @staticmethod
    def PopTextWrapPos():
        pass
    @staticmethod
    def GetFontSize() -> float:
        pass
    @staticmethod
    def GetTextLineHeightWithSpacing() -> float:
        pass
    @staticmethod
    def GetStyle() -> ImGuiStyle:
        pass
    @staticmethod
    def PushStyleColor(col: int, color: ImVec4):
        pass
    @staticmethod
    def PopStyleColor(count: int = 1):
        pass
    @staticmethod
    def PushStyleVar(idx: int, val: Union[float, ImVec2]):
        pass
    @staticmethod
    def PopStyleVar(count: int = 1):
        pass
    @staticmethod
    def Separator():
        pass
    @staticmethod
    def Spacing():
        pass
    @staticmethod
    def Dummy(size: ImVec2):
        pass
    @staticmethod
    def SameLine(offset_from_start_x: float = 0.0, spacing_w: float = -1.0):
        pass
    @staticmethod
    def Text(text: str):
        pass
    @staticmethod
    def TextWrapped(text: str):
        pass
    @staticmethod
    def TextDisabled(text: str):
        pass
    @staticmethod
    def TextUnformatted(text: str):
        pass
    @staticmethod
    def TextColored(color: ImColor, text: str):
        pass
    @staticmethod
    def Checkbox(label: str, checked: ImBool) -> bool:
        pass
    @staticmethod
    def Combo(label: str, index: ImInt, items: ImStringList, pop_max_height_in_items: int = -1) -> bool:
        pass
    @staticmethod
    def ListBox(label: str, index: ImInt, items: ImStringList, height_in_items: int = -1) -> bool:
        pass
    @staticmethod
    def Selectable(label: str, selected: bool = False, falgs: int = 0, size: ImVec2 = ImVec2()) -> bool:
        pass
    @staticmethod
    def InputText(label: str, text: ImString, flags: int = 0) -> bool:
        pass
    @staticmethod
    def InputInt(label: str, v: ImInt, step: int = 1, step_fast: int = 100, flags: int = 0) -> bool:
        pass
    @staticmethod
    def InputInt2(label: str, v: ImIntVec4, flags: int = 0) -> bool:
        pass
    @staticmethod
    def SliderInt(label: str, value: ImInt, v_min: int, v_max: int, format: str = '%.3f', falgs: int = 0) -> bool:
        pass
    @staticmethod
    def InputFloat(
        label: str, value: ImFloat, step: float = 0.0, step_fast: float = 0.0, format: str = '%.3f', falgs: int = 0
    ) -> bool:
        pass
    @staticmethod
    def SliderFloat(
        label: str, value: ImFloat, v_min: float, v_max: float, format: str = '%.3f', falgs: int = 0
    ) -> bool:
        pass
    @staticmethod
    def ColorPicker3(label: str, col: ImColor, flags: int = 0) -> bool:
        pass
    @staticmethod
    def ColorPicker4(label: str, col: ImColor, flags: int = 0) -> bool:
        pass
    @staticmethod
    def ColorEdit3(label: str, col: ImColor, flags: int = 0) -> bool:
        pass
    @staticmethod
    def ColorEdit4(label: str, col: ImColor, flags: int = 0) -> bool:
        pass
    @staticmethod
    def Button(label: str, size: ImVec2 = ImVec2()) -> bool:
        pass
    @staticmethod
    def BeginTable(id: str, column: int, flags: int = 0, outer_size: ImVec2 = ImVec2(), inner_width: float = 0.0):
        pass
    @staticmethod
    def EndTable():
        pass
    @staticmethod
    def TableNextRow(row_flags: int = 0, row_min_height: float = 0.0):
        pass
    @staticmethod
    def TableNextColumn():
        pass
