# https://github.com/ocornut/imgui/blob/master/imgui.h

"""
ImGuiWindowFlags
"""
ImGuiWindowFlags_None = 0
ImGuiWindowFlags_NoTitleBar = 1 << 0
ImGuiWindowFlags_NoResize = 1 << 1
ImGuiWindowFlags_NoMove = 1 << 2
ImGuiWindowFlags_NoScrollbar = 1 << 3
ImGuiWindowFlags_NoScrollWithMouse = 1 << 4
ImGuiWindowFlags_NoCollapse = 1 << 5
ImGuiWindowFlags_AlwaysAutoResize = 1 << 6
ImGuiWindowFlags_NoBackground = 1 << 7
ImGuiWindowFlags_NoSavedSettings = 1 << 8
ImGuiWindowFlags_NoMouseInputs = 1 << 9
ImGuiWindowFlags_MenuBar = 1 << 10
ImGuiWindowFlags_HorizontalScrollbar = 1 << 11
ImGuiWindowFlags_NoFocusOnAppearing = 1 << 12
ImGuiWindowFlags_NoBringToFrontOnFocus = 1 << 13
ImGuiWindowFlags_AlwaysVerticalScrollbar = 1 << 14
ImGuiWindowFlags_AlwaysHorizontalScrollbar = 1 << 15
ImGuiWindowFlags_AlwaysUseWindowPadding = 1 << 16
ImGuiWindowFlags_NoNavInputs = 1 << 18
ImGuiWindowFlags_NoNavFocus = 1 << 19
ImGuiWindowFlags_UnsavedDocument = 1 << 20
ImGuiWindowFlags_NoNav = ImGuiWindowFlags_NoNavInputs | ImGuiWindowFlags_NoNavFocus
ImGuiWindowFlags_NoDecoration = (
    ImGuiWindowFlags_NoTitleBar | ImGuiWindowFlags_NoResize | ImGuiWindowFlags_NoScrollbar | ImGuiWindowFlags_NoCollapse
)
ImGuiWindowFlags_NoInputs = ImGuiWindowFlags_NoMouseInputs | ImGuiWindowFlags_NoNavInputs | ImGuiWindowFlags_NoNavFocus

# [Internal]
ImGuiWindowFlags_NavFlattened = 1 << 23
ImGuiWindowFlags_ChildWindow = 1 << 24
ImGuiWindowFlags_Tooltip = 1 << 25
ImGuiWindowFlags_Popup = 1 << 26
ImGuiWindowFlags_Modal = 1 << 27
ImGuiWindowFlags_ChildMenu = 1 << 28

"""
ImGuiCond
"""
ImGuiCond_None = 0
ImGuiCond_Always = 1 << 0
ImGuiCond_Once = 1 << 1
ImGuiCond_FirstUseEver = 1 << 2
ImGuiCond_Appearing = 1 << 3

"""
ImGuiCol
"""
ImGuiCol_Text = 0
ImGuiCol_TextDisabled = 1
ImGuiCol_WindowBg = 2
ImGuiCol_ChildBg = 3
ImGuiCol_PopupBg = 4
ImGuiCol_Border = 5
ImGuiCol_BorderShadow = 6
ImGuiCol_FrameBg = 7
ImGuiCol_FrameBgHovered = 8
ImGuiCol_FrameBgActive = 9
ImGuiCol_TitleBg = 10
ImGuiCol_TitleBgActive = 11
ImGuiCol_TitleBgCollapsed = 12
ImGuiCol_MenuBarBg = 13
ImGuiCol_ScrollbarBg = 14
ImGuiCol_ScrollbarGrab = 15
ImGuiCol_ScrollbarGrabHovered = 16
ImGuiCol_ScrollbarGrabActive = 17
ImGuiCol_CheckMark = 18
ImGuiCol_SliderGrab = 19
ImGuiCol_SliderGrabActive = 20
ImGuiCol_Button = 21
ImGuiCol_ButtonHovered = 22
ImGuiCol_ButtonActive = 23
ImGuiCol_Header = 24
ImGuiCol_HeaderHovered = 25
ImGuiCol_HeaderActive = 26
ImGuiCol_Separator = 27
ImGuiCol_SeparatorHovered = 28
ImGuiCol_SeparatorActive = 29
ImGuiCol_ResizeGrip = 30
ImGuiCol_ResizeGripHovered = 31
ImGuiCol_ResizeGripActive = 32
ImGuiCol_Tab = 33
ImGuiCol_TabHovered = 34
ImGuiCol_TabActive = 35
ImGuiCol_TabUnfocused = 36
ImGuiCol_TabUnfocusedActive = 37
ImGuiCol_PlotLines = 38
ImGuiCol_PlotLinesHovered = 39
ImGuiCol_PlotHistogram = 40
ImGuiCol_PlotHistogramHovered = 41
ImGuiCol_TableHeaderBg = 42
ImGuiCol_TableBorderStrong = 43
ImGuiCol_TableBorderLight = 44
ImGuiCol_TableRowBg = 45
ImGuiCol_TableRowBgAlt = 46
ImGuiCol_TextSelectedBg = 47
ImGuiCol_DragDropTarget = 48
ImGuiCol_NavHighlight = 49
ImGuiCol_NavWindowingHighlight = 50
ImGuiCol_NavWindowingDimBg = 51
ImGuiCol_ModalWindowDimBg = 52

"""
ImGuiTableFlags
"""
ImGuiTableFlags_None = 0
ImGuiTableFlags_Resizable = 1 << 0
ImGuiTableFlags_Reorderable = 1 << 1
ImGuiTableFlags_Hideable = 1 << 2
ImGuiTableFlags_Sortable = 1 << 3
ImGuiTableFlags_NoSavedSettings = 1 << 4
ImGuiTableFlags_ContextMenuInBody = 1 << 5

# Decorations
ImGuiTableFlags_RowBg = 1 << 6
ImGuiTableFlags_BordersInnerH = 1 << 7
ImGuiTableFlags_BordersOuterH = 1 << 8
ImGuiTableFlags_BordersInnerV = 1 << 9
ImGuiTableFlags_BordersOuterV = 1 << 10
ImGuiTableFlags_BordersH = ImGuiTableFlags_BordersInnerH | ImGuiTableFlags_BordersOuterH
ImGuiTableFlags_BordersV = ImGuiTableFlags_BordersInnerV | ImGuiTableFlags_BordersOuterV
ImGuiTableFlags_BordersInner = ImGuiTableFlags_BordersInnerV | ImGuiTableFlags_BordersInnerH
ImGuiTableFlags_BordersOuter = ImGuiTableFlags_BordersOuterV | ImGuiTableFlags_BordersOuterH
ImGuiTableFlags_Borders = ImGuiTableFlags_BordersInner | ImGuiTableFlags_BordersOuter
ImGuiTableFlags_NoBordersInBody = 1 << 11
ImGuiTableFlags_NoBordersInBodyUntilResize = 1 << 12

# Sizing Policy
ImGuiTableFlags_SizingFixedFit = 1 << 13
ImGuiTableFlags_SizingFixedSame = 2 << 13
ImGuiTableFlags_SizingStretchProp = 3 << 13
ImGuiTableFlags_SizingStretchSame = 4 << 13

# Sizing Extra Options
ImGuiTableFlags_NoHostExtendX = 1 << 16
ImGuiTableFlags_NoHostExtendY = 1 << 17
ImGuiTableFlags_NoKeepColumnsVisible = 1 << 18
ImGuiTableFlags_PreciseWidths = 1 << 19

# Clipping
ImGuiTableFlags_NoClip = 1 << 20

# Padding
ImGuiTableFlags_PadOuterX = 1 << 21
ImGuiTableFlags_NoPadOuterX = 1 << 22
ImGuiTableFlags_NoPadInnerX = 1 << 23

# Scrolling
ImGuiTableFlags_ScrollX = 1 << 24
ImGuiTableFlags_ScrollY = 1 << 25

# Sorting
ImGuiTableFlags_SortMulti = 1 << 26
ImGuiTableFlags_SortTristate = 1 << 27

ImGuiTableFlags_SizingMask_ = (
    ImGuiTableFlags_SizingFixedFit
    | ImGuiTableFlags_SizingFixedSame
    | ImGuiTableFlags_SizingStretchProp
    | ImGuiTableFlags_SizingStretchSame
)

"""
ImGuiFreeTypeBuilderFlags
"""
ImGuiFreeTypeBuilderFlags_NoHinting = 1 << 0 
ImGuiFreeTypeBuilderFlags_NoAutoHint = 1 << 1
ImGuiFreeTypeBuilderFlags_ForceAutoHint = 1 << 2
ImGuiFreeTypeBuilderFlags_LightHinting = 1 << 3
ImGuiFreeTypeBuilderFlags_MonoHinting = 1 << 4
ImGuiFreeTypeBuilderFlags_Bold = 1 << 5
ImGuiFreeTypeBuilderFlags_Oblique = 1 << 6
ImGuiFreeTypeBuilderFlags_Monochrome = 1 << 7
ImGuiFreeTypeBuilderFlags_LoadColor = 1 << 8
ImGuiFreeTypeBuilderFlags_Bitmap = 1 << 9

"""
ImGuiStyleVar
"""
ImGuiStyleVar_Alpha = 0  # float     Alpha
ImGuiStyleVar_DisabledAlpha = 1  # float     DisabledAlpha
ImGuiStyleVar_WindowPadding = 2  # ImVec2    WindowPadding
ImGuiStyleVar_WindowRounding = 3  # float     WindowRounding
ImGuiStyleVar_WindowBorderSize = 4  # float     WindowBorderSize
ImGuiStyleVar_WindowMinSize = 5  # ImVec2    WindowMinSize
ImGuiStyleVar_WindowTitleAlign = 6  # ImVec2    WindowTitleAlign
ImGuiStyleVar_ChildRounding = 7  # float     ChildRounding
ImGuiStyleVar_ChildBorderSize = 8  # float     ChildBorderSize
ImGuiStyleVar_PopupRounding = 9  # float     PopupRounding
ImGuiStyleVar_PopupBorderSize = 10  # float     PopupBorderSize
ImGuiStyleVar_FramePadding = 11  # ImVec2    FramePadding
ImGuiStyleVar_FrameRounding = 12  # float     FrameRounding
ImGuiStyleVar_FrameBorderSize = 13  # float     FrameBorderSize
ImGuiStyleVar_ItemSpacing = 14  # ImVec2    ItemSpacing
ImGuiStyleVar_ItemInnerSpacing = 15  # ImVec2    ItemInnerSpacing
ImGuiStyleVar_IndentSpacing = 16  # float     IndentSpacing
ImGuiStyleVar_CellPadding = 17  # ImVec2    CellPadding
ImGuiStyleVar_ScrollbarSize = 18  # float     ScrollbarSize
ImGuiStyleVar_ScrollbarRounding = 19  # float     ScrollbarRounding
ImGuiStyleVar_GrabMinSize = 20  # float     GrabMinSize
ImGuiStyleVar_GrabRounding = 21  # float     GrabRounding
ImGuiStyleVar_TabRounding = 22  # float     TabRounding
ImGuiStyleVar_ButtonTextAlign = 23  # ImVec2    ButtonTextAlign
ImGuiStyleVar_SelectableTextAlign = 24  # ImVec2    SelectableTextAlign

"""
ImGuiInputTextFlags
"""
ImGuiInputTextFlags_None = 0
ImGuiInputTextFlags_CharsDecimal = 1 << 0
ImGuiInputTextFlags_CharsHexadecimal = 1 << 1
ImGuiInputTextFlags_CharsUppercase = 1 << 2
ImGuiInputTextFlags_CharsNoBlank = 1 << 3
ImGuiInputTextFlags_AutoSelectAll = 1 << 4
ImGuiInputTextFlags_EnterReturnsTrue = 1 << 5
ImGuiInputTextFlags_CallbackCompletion = 1 << 6
ImGuiInputTextFlags_CallbackHistory = 1 << 7
ImGuiInputTextFlags_CallbackAlways = 1 << 8
ImGuiInputTextFlags_CallbackCharFilter = 1 << 9
ImGuiInputTextFlags_AllowTabInput = 1 << 10
ImGuiInputTextFlags_CtrlEnterForNewLine = 1 << 11
ImGuiInputTextFlags_NoHorizontalScroll = 1 << 12
ImGuiInputTextFlags_AlwaysInsertMode = 1 << 13
ImGuiInputTextFlags_ReadOnly = 1 << 14
ImGuiInputTextFlags_Password = 1 << 15
ImGuiInputTextFlags_NoUndoRedo = 1 << 16
ImGuiInputTextFlags_CharsScientific = 1 << 17
ImGuiInputTextFlags_CallbackResize = 1 << 18
ImGuiInputTextFlags_CallbackEdit = 1 << 19
# [Internal]
ImGuiInputTextFlags_Multiline = 1 << 20
ImGuiInputTextFlags_NoMarkEdited = 1 << 21


"""
ImGuiColorEditFlags
"""
ImGuiColorEditFlags_None = 0
ImGuiColorEditFlags_NoAlpha = 1 << 1
ImGuiColorEditFlags_NoPicker = 1 << 2
ImGuiColorEditFlags_NoOptions = 1 << 3
ImGuiColorEditFlags_NoSmallPreview = 1 << 4
ImGuiColorEditFlags_NoInputs = 1 << 5
ImGuiColorEditFlags_NoTooltip = 1 << 6
ImGuiColorEditFlags_NoLabel = 1 << 7
ImGuiColorEditFlags_NoSidePreview = 1 << 8
ImGuiColorEditFlags_NoDragDrop = 1 << 9
ImGuiColorEditFlags_NoBorder = 1 << 10

# User Options (right-click on widget to change some of them).
ImGuiColorEditFlags_AlphaBar = 1 << 16
ImGuiColorEditFlags_AlphaPreview = 1 << 17
ImGuiColorEditFlags_AlphaPreviewHalf = 1 << 18
ImGuiColorEditFlags_HDR = 1 << 19
ImGuiColorEditFlags_DisplayRGB = 1 << 20
ImGuiColorEditFlags_DisplayHSV = 1 << 21
ImGuiColorEditFlags_DisplayHex = 1 << 22
ImGuiColorEditFlags_Uint8 = 1 << 23
ImGuiColorEditFlags_Float = 1 << 24
ImGuiColorEditFlags_PickerHueBar = 1 << 25
ImGuiColorEditFlags_PickerHueWheel = 1 << 26
ImGuiColorEditFlags_InputRGB = 1 << 27
ImGuiColorEditFlags_InputHSV = 1 << 28

ImGuiColorEditFlags__OptionsDefault = (
    ImGuiColorEditFlags_Uint8
    | ImGuiColorEditFlags_DisplayRGB
    | ImGuiColorEditFlags_InputRGB
    | ImGuiColorEditFlags_PickerHueBar
)

# [Internal] Masks
ImGuiColorEditFlags__DisplayMask = (
    ImGuiColorEditFlags_DisplayRGB | ImGuiColorEditFlags_DisplayHSV | ImGuiColorEditFlags_DisplayHex
)
ImGuiColorEditFlags__DataTypeMask = ImGuiColorEditFlags_Uint8 | ImGuiColorEditFlags_Float
ImGuiColorEditFlags__PickerMask = ImGuiColorEditFlags_PickerHueWheel | ImGuiColorEditFlags_PickerHueBar
ImGuiColorEditFlags__InputMask = ImGuiColorEditFlags_InputRGB | ImGuiColorEditFlags_InputHSV


"""
ImGuiFocusedFlags
"""
ImGuiFocusedFlags_None = 0
ImGuiFocusedFlags_ChildWindows = 1 << 0
ImGuiFocusedFlags_RootWindow = 1 << 1
ImGuiFocusedFlags_AnyWindow = 1 << 2
ImGuiFocusedFlags_NoPopupHierarchy = 1 << 3
ImGuiFocusedFlags_RootAndChildWindows = ImGuiFocusedFlags_RootWindow | ImGuiFocusedFlags_ChildWindows
